package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.util.Arrays;
import java.util.List;

@Component
public class ExampleClient {

    @Autowired
    private EmployeeRepository repo;

    public void run() {
        List<Employee> employees = createEmployees();
        repo.saveAll(employees);

        System.out.println(" -- finding all employees --");
        Iterable<Employee> all = repo.findAll();
        all.forEach(System.out::println);

        System.out.println(" -- finding SalaryInfo for IT dept --");
        List<SalaryInfo> list = repo.findByDept("IT", SalaryInfo.class);
        list.forEach(System.out::println);

        System.out.println(" -- finding ContactInfo for IT dept --");
        List<ContactInfo> list2 = repo.findByDept("IT", ContactInfo.class);
        list2.forEach(System.out::println);
    }

    private List<Employee> createEmployees() {
        return Arrays.asList(
                Employee.create("Diana", "Admin", 3000, "111-111-111"),
                Employee.create("Mike", "IT", 1000, "222-222-222"),
                Employee.create("Rose", "Admin", 4000, "333-333-333"),
                Employee.create("Sara", "Admin", 3500, "444-444-444"),
                Employee.create("Tanaka", "IT", 3000, "555-555-555"),
                Employee.create("Charlie", "IT", 450, "666-666-666")
        );
    }
}